diff --git a/isisd/isis_srv6.c b/isisd/isis_srv6.c
index 6bb6ff330934..daa7a78ebe68 100644
--- a/isisd/isis_srv6.c
+++ b/isisd/isis_srv6.c
@@ -20,6 +20,29 @@
 /* Local variables and functions */
 DEFINE_MTYPE_STATIC(ISISD, ISIS_SRV6_SID, "ISIS SRv6 Segment ID");
 
+/**
+ * Fill in SRv6 SID Structure Sub-Sub-TLV with information from an SRv6 SID.
+ *
+ * @param sid				    SRv6 SID configuration
+ * @param structure_subsubtlv	SRv6 SID Structure Sub-Sub-TLV to be updated
+ */
+void isis_srv6_sid_structure2subsubtlv(
+	const struct isis_srv6_sid *sid,
+	struct isis_srv6_sid_structure_subsubtlv *structure_subsubtlv)
+{
+	/* Set Locator Block length */
+	structure_subsubtlv->loc_block_len = sid->structure.loc_block_len;
+
+	/* Set Locator Node length */
+	structure_subsubtlv->loc_node_len = sid->structure.loc_node_len;
+
+	/* Set Function length */
+	structure_subsubtlv->func_len = sid->structure.func_len;
+
+	/* Set Argument length */
+	structure_subsubtlv->arg_len = sid->structure.arg_len;
+}
+
 /**
  * Fill in SRv6 End SID Sub-TLV with information from an SRv6 SID.
  *
diff --git a/isisd/isis_srv6.h b/isisd/isis_srv6.h
index 3a3d4ea015d1..89fe723b5d53 100644
--- a/isisd/isis_srv6.h
+++ b/isisd/isis_srv6.h
@@ -113,6 +113,9 @@ extern void isis_srv6_area_term(struct isis_area *area);
 void isis_srv6_init(void);
 void isis_srv6_term(void);
 
+void isis_srv6_sid_structure2subsubtlv(
+	const struct isis_srv6_sid *sid,
+	struct isis_srv6_sid_structure_subsubtlv *structure_subsubtlv);
 void isis_srv6_end_sid2subtlv(const struct isis_srv6_sid *sid,
 			      struct isis_srv6_end_sid_subtlv *sid_subtlv);
 void isis_srv6_locator2tlv(const struct isis_srv6_locator *loc,
